/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *	stk504_lcd.cp`ƌ^錾
 *
 * \par Application note:
 *	AVR063: STK504pLCDײ
 *
 * \par Documentation:
 *	IȺގAxׁ߲A߲אݒAx޲ɊւĂreadme.html
 *	B
 *
 * \author
 *	Atmel Corporation	: http://www.atmel.com \n
 *	xEҰ			: avr@atmel.com
 *
 * $Name: RELEASE_1_1 $
 * $Revision: 1.3 $
 * $RCSfile: stk504_lcd.h,v $
 * $Date: 2006/02/16 18:04:59 $  \n
 *****************************************************************************/

/**************************************************************/
// `
/**************************************************************/
#define LCD_INITIAL_CONTRAST	0x0F		// L͈͂0x00`0x0F
#define LCD_REGISTER_COUNT		20
#define LCD_TIMER_SEED			5			// XVԊuv(~ڰю)

// LpLCD(L)`
// `=bbbnnnnn(bޯĔԍ(0`7),nLCDDRԍ(0`19))
#define MO			0x60
#define TU			0xE0
#define WE			0x61
#define TH			0xE1
#define FR			0x62
#define SA			0xE2
#define SU			0x63

#define MO_			0x40
#define TU_			0xC0
#define WE_			0x41
#define TH_			0xC1
#define FR_			0x42
#define SA_			0xC2
#define SU_			0x43

#define BC8			0x51
#define G8			0xD0

#define segIN		0x50
#define segOUT		0xC4
#define AVR			0xF2
#define BELL		0x4F
#define WARNING		0xCF
#define SG0			0xE3
#define SG1			0xE8
#define SG2			0xED
#define KEY			0x52
#define WARM		0xD1
#define ICE			0x04
#define COL			0x44
#define DOT			0x84	// LCDĊ蓖ĕ\ł"P"

#define S0			0x83
#define S1			0xC3
#define S2			0xA3
#define S3			0xC8
#define S4			0xA8
#define S5			0xCD
#define S6			0xAD
#define S7			0xD2
#define S8			0xB2
#define S9			0x92
#define S10			0x8D
#define S11			0x88

/**************************************************************/
// ϸ
/**************************************************************/
#define pLCDREG (*(unsigned char *)(0xEC))					// ޲L!!! (ATmega3290)
#define LCD_CONTRAST_LEVEL(level) LCDCCR=(0x0F & level);	// ޲L!!! (ATmega3290)

/**************************************************************/
// S֐
/**************************************************************/
void LCD_init( void );
void LCD_AllSegments( unsigned char input );
void LCD_Update( void );
void LCD_BarSeg ( unsigned char value );
void LCD_PutChar( unsigned char c, unsigned char digit );
void LCD_PutDigit( unsigned char c, unsigned char digit );
void LCD_SetSeg( unsigned char symbol, unsigned char val );

/**************************************************************/
// Sϐ
/**************************************************************/
union _LCD_status{
  unsigned char allFields;
  struct{
	unsigned char updateRequired : 1;	// LCDDRޯ̧LCDDRʗvB'0'ݒLCDDRޯ̧XVLCDDRXVhƂł܂B
	unsigned char updateComplete : 1;	// LCDDRޯ̧LCDDRʊBLCDDRޯ̧̔fɎgp邱Ƃł܂B
	unsigned char unused : 6;
  };
};
volatile extern union _LCD_status LCD_status;

extern unsigned char LCD_timer;			// LCDXVԊu߂܂B
extern unsigned char LCD_displayData[LCD_REGISTER_COUNT];
